/*
**	Apple Macintosh Developer Technical Support
**
**	Glue to call UGLibrary in a code resource from a PPC application
**
**	by Jim Luther, Apple Developer Technical Support
**
**	File:		UGLibraryGlue.c
**
**	Copyright  1995 Apple Computer, Inc.
**	All rights reserved.
**
**	You may incorporate this sample code into your applications without
**	restriction, though the sample code has been provided "AS IS" and the
**	responsibility for its operation is 100% yours.  However, what you are
**	not permitted to do is to redistribute the source as "DSC Sample Code"
**	after having made changes. If you're going to re-distribute the source,
**	we require that you make it clear in the source that the code was
**	descended from Apple Sample Code, but that you've made changes.
*/

#include <Types.h>
#include <MixedMode.h>
#include "UGLibraryGlue.h"

/*
**	When linked with UGLibrary.o, the main routine gets function pointers to
**	the routines in UGLibrary and puts them into the UGEntryPoints structure.
**
**	This file must be linked into the stand-alone code resource first!
*/
void	main(UGEntryPoints *ePoints)
{
	/* Set up the entry points */
	ePoints->UGOpenFile = UGOpenFile;
	ePoints->UGCloseFile = UGCloseFile;
	ePoints->UGCreateFile = UGCreateFile;
	ePoints->UGNewUser = UGNewUser;
	ePoints->UGDeleteUser = UGDeleteUser;
	ePoints->UGRenameUser = UGRenameUser;
	ePoints->UGGetUserInfo = UGGetUserInfo;
	ePoints->UGSetUserInfo = UGSetUserInfo;
	ePoints->UGAuthenticateUser = UGAuthenticateUser;
	ePoints->UGNewGroup = UGNewGroup;
	ePoints->UGDeleteGroup = UGDeleteGroup;
	ePoints->UGRenameGroup = UGRenameGroup;
	ePoints->UGGetGroupInfo = UGGetGroupInfo;
	ePoints->UGAssignUserToGroup = UGAssignUserToGroup;
	ePoints->UGDeleteUserFromGroup = UGDeleteUserFromGroup;
	ePoints->UGGetULInfo = UGGetULInfo;
	ePoints->UGSetULInfo = UGSetULInfo;
}